-- 跨服云购，礼金购买
Lua_CrossServerGiftBuyPlane  = class("Lua_CrossServerGiftBuyPlane",Lua_DisplayObject);
function Lua_CrossServerGiftBuyPlane:ctor(p)
	self:superCall("ctor", p, "CrossServerGoldPlane_skin");
end

function Lua_CrossServerGiftBuyPlane:buildShowItem()
	self:superCall("buildShowItem");

	self.buy_one.text = LanUtil.getValue(141403);
	self.buy_ten.text = LanUtil.getValue(141404);
	self.gold1:setAltas("icon_atlas_3", "money_209000002");
	self.gold2:setAltas("icon_atlas_3", "money_209000002");

	self.severDragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 408, 80));
	self.severDragContainer:setLocation(-282, 130);

	self.rewardDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 336, 160));
	self.rewardDragList:setLocation(-270, -55, 0);
	self.rewardDragList:setListCell(CrossServerGiftRewardItem, 80, 85, 4);

	self.itemDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 560, 460));
	self.itemDragList:setLocation(230, -18, 0);
	self.itemDragList:setListCell(CrossServerGiftBuyItem, 210, 275, 2);
	self.selectCheckBoxOen:addBoxChange(self, self.onSelectBoxOenClick); -- 购买一次
	self.selectCheckBoxTen:addBoxChange(self, self.onSelectBoxTenClick); -- 购买十次

	self:addLuaEvent("UPDARE_CROSS_RURCHASING_INFO", self, self.updateGoldBuyInfo);
	self:updateGoldBuyInfo();
end

function Lua_CrossServerGiftBuyPlane:updateGoldBuyInfo()
	local itemArr = DataCenter.crossServerPurchasingData:getActiviteItemInfo(Lua_CrossServerPurchasingData.GIFT_TYPE);
	self.itemDragList:setLuaArrayData(itemArr, true);

	local rewardArr = DataCenter.crossServerPurchasingData:getActiviteRewardInf(Lua_CrossServerPurchasingData.GIFT_TYPE);
	self.rewardDragList:setLuaArrayData(rewardArr, true);

	local severArr = DataCenter.crossServerPurchasingData:getActiviteRecordInfo(Lua_CrossServerPurchasingData.GIFT_TYPE);
	self.severDragContainer:removeAllChildren();
	for i = 1, severArr:getSize() do
		self.severItem = showGiftRecordItem.new(self.severDragContainer.sub)
		self.severDragContainer:addSubContainer(self.severItem, false);
		self.severDragContainer.childrenList[i]:setData(severArr[i]);
	end
	self.severDragContainer:updateChildPos();
	self.severDragContainer:moveToChildIndex(1, true);

	self.selectCheckBoxOen.seleted = DataCenter.crossServerPurchasingData.gift_buy_num == 0;
	self.selectCheckBoxTen.seleted = DataCenter.crossServerPurchasingData.gift_buy_num ~= 0;
	self.moneyOne.text = DataCenter.crossServerPurchasingData.giftNum;
	self.moneyTen.text = DataCenter.crossServerPurchasingData.giftNum * 10;
end

function Lua_CrossServerGiftBuyPlane:onSelectBoxOenClick()
	DataCenter.crossServerPurchasingData.gift_buy_num = 0;
	self.selectCheckBoxTen.seleted = false;
end

function Lua_CrossServerGiftBuyPlane:onSelectBoxTenClick()
	DataCenter.crossServerPurchasingData.gift_buy_num = 1;
	self.selectCheckBoxOen.seleted = false;
end

function Lua_CrossServerGiftBuyPlane:dispose()	
	if self.severDragList ~= nil then
		self.severDragList:dispose()
		self.severDragList = nil;
	end
	if self.rewardDragList ~= nil then
		self.rewardDragList:dispose()
		self.rewardDragList = nil;
	end
	if self.itemDragList ~= nil then
		self.itemDragList:dispose()
		self.itemDragList = nil;
	end
	self:superCall("dispose");
end










-- 云购记录
showGiftRecordItem = class("showGiftRecordItem", Lua_DragContainerItem);
function showGiftRecordItem:ctor(p)
	self:superCall("ctor", p); 
end

function showGiftRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.descTxt = UICreate.createLabel(self.content, "", -196, 34, 398, 30, 22);
	self.descTxt.spacingY = 2;
	self.descTxt.pivot =  UIWidget.Pivot.TopLeft;
	self.descTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.descTxt.clickScale = false;
	self.descTxt:setDepth(2);
end

function showGiftRecordItem:setData(data)
	self.data = data;

	local nameStr = "[u][url=playerClick_"..data.role_id.."]"..data.role_name.."[/url][/u]";
	local str;
	if data.value == 1 then
		str = LanUtil.formateStr(LanUtil.getValue(141409),tostring(data.server_name), nameStr)
	else
		str = LanUtil.formateStr(LanUtil.getValue(141410),tostring(data.server_name), nameStr, tostring(data.value))
	end
	self.descTxt.text = str;
end

function showGiftRecordItem:onPlayerSoundClick(go)
	local urlStr = self.descTxt:getUrlByMousePos();
	if urlStr ~= nil then
		Lua_ChatUtil.playerMenuPopListShow({role_id = self.data.role_id, name = self.data.role_name});
	end
end

function showGiftRecordItem:getHeight()
	return self.descTxt.height;
end

function showGiftRecordItem:dispose()
	self:superCall("dispose");
end










CrossServerGiftRewardItem = class("CrossServerGiftRewardItem", Lua_ListCell);
function CrossServerGiftRewardItem:ctor(p)
	self:superCall("ctor", p); 
end

function CrossServerGiftRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.image = Lua_ToolImage.new(self.content);
	self.image:setDepth(6);
	self.image:setCanClick(false);
	self.image:setScale(0.88,0.88);
end

function CrossServerGiftRewardItem:setData(data)
	self.data = data;
	self.image.data = data;
end

function CrossServerGiftRewardItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data,false,nil,false);
	end
end


function CrossServerGiftRewardItem:dispose()
	self:superCall("dispose");
end











CrossServerGiftBuyItem = class("CrossServerGiftBuyItem", Lua_ListCell);
function CrossServerGiftBuyItem:ctor(p)
	self:superCall("ctor", p, "CrossServerPurchasingItem_skin"); 
end

function CrossServerGiftBuyItem:buildShowItem()
	self:superCall("buildShowItem");

	self.image = Lua_ToolImage.new(self.content);
	self.image:setDepth(6);
	self.image:setScale(0.88, 0.88);
	self.image:setLocation(-88, 21, 0);

	self.subBar:setText(0 .. "/" .. 0);
	self.subBar:setMaxValue(0);
	self.subBar:setValue(0);

	self.subButton:addClickFuntion(self, self.onBuyButtonClick);
end

function CrossServerGiftBuyItem:setData(data)
	self.data = data;

	self.image.data = data.itemVo;

	self.name.text = data.itemVo.name;
	self.mun.text = LanUtil.formateStr(LanUtil.getValue(141406),tostring(data.reward_number));

	self.subBar:setText(tostring(data.cur_schedule) .. "/" .. tostring(data.act_schedule));
	local dic = data.max_buy_times;
	if DataCenter.crossServerPurchasingData.isInfiniteBuy == true or data.state == 1 then
		dic = LanUtil.getValue(141418);
		self.subBar:setText(tostring(data.cur_schedule) .. "/" .. tostring(dic));
	end
	self.subBar:setMaxValue(data.act_schedule);
	self.subBar:setValue(data.cur_schedule);
	
	self.buy_mun.text = LanUtil.formateStr(LanUtil.getValue(141407),tostring(data.cur_buy_times),tostring(dic));

	if data.state == 0 then
		self.subButton.label = LanUtil.getValue(141411);
	else
		self.subButton.label = LanUtil.getValue(141413);
	end
end

function CrossServerGiftBuyItem:onBuyButtonClick()
	if self.data.state == 0 then
		if DataCenter.neverTip:getNeverValue("Show_Gift_Tip") == false then
			if DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD) < DataCenter.crossServerPurchasingData.getGiftPrice then
				Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {
					owner = self,
					neverTip = "Show_Gift_Tip",
					des = LanUtil.getValue(141416),
					type = 1,
					subFun = self.onSubCallback
				});
			else
				Lua_ProxyManager.getProxy("Lua_CrossServerPurchasingProxy"):sCrossServerBuyInfo(DataCenter.crossServerPurchasingData.gift_buy_num,self.data.index);
			end
		else
			self:onSubCallback();
		end
	else
		Lua_ProxyManager.getProxy("Lua_CrossServerPurchasingProxy"):sCrossServerRewardInfo(self.data.index);
		Lua_WindowUtil.openWin("Lua_CrossServerRewardWindow", WinParam.ACTION_OPEN,
			{itemVo = self.data.itemVo, reward_number = self.data.reward_number});
	end
end

function CrossServerGiftBuyItem:onSubCallback()
	local giftMoney = DataCenter.moneyData:getMoney(Lua_MoneyData.BIND_GOLD);
	local goldMoney = DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD);
	local num = goldMoney + giftMoney;
	if num < DataCenter.crossServerPurchasingData.getGiftPrice then
		Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {
			owner = self,
			des = LanUtil.getValue(110818),
			type = 1,
			subFun = self.onSubCallbackClick
		});
	else
		Lua_ProxyManager.getProxy("Lua_CrossServerPurchasingProxy"):sCrossServerBuyInfo(DataCenter.crossServerPurchasingData.gift_buy_num,self.data.index);
	end
end

function CrossServerGiftBuyItem:onSubCallbackClick()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow");
	Lua_WindowUtil.openWin("Lua_CrossServerPurchasingWindow",WinParam.ACTION_CLOSE);
end

function CrossServerGiftBuyItem:dispose()
	self:superCall("dispose");
end