-- 跨服云购，元宝购买
Lua_CrossServerGoldBuyPlane  = class("Lua_CrossServerGoldBuyPlane",Lua_DisplayObject);
function Lua_CrossServerGoldBuyPlane:ctor(p)
	self:superCall("ctor", p, "CrossServerGoldPlane_skin");
end

function Lua_CrossServerGoldBuyPlane:buildShowItem()
	self:superCall("buildShowItem");

	self.buy_one.text = LanUtil.getValue(141403);
	self.buy_ten.text = LanUtil.getValue(141404);

	self.severDragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 408, 80));
	self.severDragContainer:setLocation(-282, 130);

	self.rewardDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 336, 160));
	self.rewardDragList:setLocation(-270, -55, 0);
	self.rewardDragList:setListCell(Lua_CrossServerGoldRewardItem, 80, 85, 4);

	self.itemDragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 560, 460));
	self.itemDragList:setLocation(230, -18, 0);
	self.itemDragList:setListCell(Lua_CrossServerGoldBuyItem, 210, 275, 2);

	self.selectCheckBoxOen:addBoxChange(self, self.onSelectBoxOenClick); -- 购买一次
	self.selectCheckBoxTen:addBoxChange(self, self.onSelectBoxTenClick); -- 购买十次

	self:addLuaEvent("UPDARE_CROSS_RURCHASING_INFO", self, self.updateGoldBuyInfo);
	self:updateGoldBuyInfo();
end

function Lua_CrossServerGoldBuyPlane:updateGoldBuyInfo()
	local itemArr = DataCenter.crossServerPurchasingData:getActiviteItemInfo(Lua_CrossServerPurchasingData.GOLD_TYPE);
	self.itemDragList:setLuaArrayData(itemArr, true);

	local rewardArr = DataCenter.crossServerPurchasingData:getActiviteRewardInf(Lua_CrossServerPurchasingData.GOLD_TYPE);
	self.rewardDragList:setLuaArrayData(rewardArr, true);

	local severArr = DataCenter.crossServerPurchasingData:getActiviteRecordInfo(Lua_CrossServerPurchasingData.GOLD_TYPE);
	self.severDragContainer:removeAllChildren();
	for i = 1, severArr:getSize() do
		self.severItem = Lua_CrossSeverShowRecordItem.new(self.severDragContainer.sub)
		self.severDragContainer:addSubContainer(self.severItem, false);
		self.severDragContainer.childrenList[i]:setData(severArr[i]);
	end
	self.severDragContainer:updateChildPos();
	self.severDragContainer:moveToChildIndex(1, true);

	self.selectCheckBoxOen.seleted = DataCenter.crossServerPurchasingData.gold_buy_num == 0;
	self.selectCheckBoxTen.seleted = DataCenter.crossServerPurchasingData.gold_buy_num ~= 0;
	self.moneyOne.text = DataCenter.crossServerPurchasingData.goldNum;
	self.moneyTen.text = DataCenter.crossServerPurchasingData.goldNum * 10;
end

function Lua_CrossServerGoldBuyPlane:onSelectBoxOenClick()
	DataCenter.crossServerPurchasingData.gold_buy_num = 0;
	self.selectCheckBoxTen.seleted = false;
end

function Lua_CrossServerGoldBuyPlane:onSelectBoxTenClick()
	DataCenter.crossServerPurchasingData.gold_buy_num = 1;
	self.selectCheckBoxOen.seleted = false;
end

function Lua_CrossServerGoldBuyPlane:dispose()	
	if self.severDragList ~= nil then
		self.severDragList:dispose()
		self.severDragList = nil;
	end
	if self.rewardDragList ~= nil then
		self.rewardDragList:dispose()
		self.rewardDragList = nil;
	end
	if self.itemDragList ~= nil then
		self.itemDragList:dispose()
		self.itemDragList = nil;
	end

	self:superCall("dispose");
end















-- 云购记录
Lua_CrossSeverShowRecordItem = class("Lua_CrossSeverShowRecordItem", Lua_DragContainerItem);
function Lua_CrossSeverShowRecordItem:ctor(p)
	self:superCall("ctor", p); 
end

function Lua_CrossSeverShowRecordItem:buildShowItem()
	self:superCall("buildShowItem");

	self.descTxt = UICreate.createLabel(self.content, "", -196, 34, 398, 30, 22);
	self.descTxt.spacingY = 2;
	self.descTxt.pivot =  UIWidget.Pivot.TopLeft;
	self.descTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.descTxt.clickScale = false;
	self.descTxt:setDepth(2);
end

function Lua_CrossSeverShowRecordItem:setData(data)
	self.data = data;

	local nameStr = "[u][url=playerClick_"..data.role_id.."]"..data.role_name.."[/url][/u]";
	local str;
	if data.value == 1 then
		str = LanUtil.formateStr(LanUtil.getValue(141409), tostring(data.server_name), nameStr)
	else
		str = LanUtil.formateStr(LanUtil.getValue(141410), tostring(data.server_name), nameStr, tostring(data.value))
	end
	self.descTxt.text = str;
end

function Lua_CrossSeverShowRecordItem:getHeight()
	return self.descTxt.height + 10;
end

function Lua_CrossSeverShowRecordItem:onPlayerSoundClick(go)
	local urlStr = self.descTxt:getUrlByMousePos();
	if urlStr ~= nil then
		Lua_ChatUtil.playerMenuPopListShow({role_id = self.data.role_id, name = self.data.role_name});
	end
end

function Lua_CrossSeverShowRecordItem:dispose()
	self:superCall("dispose");
end










Lua_CrossServerGoldRewardItem = class("Lua_CrossServerGoldRewardItem", Lua_ListCell);
function Lua_CrossServerGoldRewardItem:ctor(p)
	self:superCall("ctor", p); 
end

function Lua_CrossServerGoldRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.image = Lua_ToolImage.new(self.content);
	self.image:setDepth(6);
	self.image:setCanClick(false);
	self.image:setScale(0.88, 0.88);
end

function Lua_CrossServerGoldRewardItem:setData(data)
	self.data = data;
	self.image.data = data;
end

function Lua_CrossServerGoldRewardItem:onPlayerSoundClick(go)
	if self.data ~= nil then
		Lua_PackUtil.showItemInfo(self.data, false, nil, false);
	end
end

function Lua_CrossServerGoldRewardItem:dispose()
	self:superCall("dispose");
end










Lua_CrossServerGoldBuyItem = class("Lua_CrossServerGoldBuyItem", Lua_ListCell);
function Lua_CrossServerGoldBuyItem:ctor(p)
	self:superCall("ctor", p, "CrossServerPurchasingItem_skin"); 
end

function Lua_CrossServerGoldBuyItem:buildShowItem()
	self:superCall("buildShowItem");

	self.image = Lua_ToolImage.new(self.content);
	self.image:setDepth(6);
	self.image:setLocation(-88, 21, 0);
	self.image:setScale(0.88, 0.88);

	self.subButton:addClickFuntion(self, self.onBuyButtonClick);
end

function Lua_CrossServerGoldBuyItem:setData(data)
	self.data = data;

	self.image.data = data.itemVo;

	self.name.text = data.itemVo.name;
	self.mun.text = LanUtil.formateStr(LanUtil.getValue(141406),tostring(data.reward_number));

	self.subBar:setText(tostring(data.cur_schedule) .. "/" .. tostring(data.act_schedule));
	local dic = data.max_buy_times;
	if DataCenter.crossServerPurchasingData.isInfiniteBuy == true or data.state == 1 then
		dic = LanUtil.getValue(141418);
		self.subBar:setText(tostring(data.cur_schedule) .. "/" .. tostring(dic));
	end
	self.subBar:setMaxValue(data.act_schedule);
	self.subBar:setValue(data.cur_schedule);

	self.buy_mun.text = LanUtil.formateStr(LanUtil.getValue(141407), tostring(data.cur_buy_times), tostring(dic));

	if data.state == 0 then
		self.subButton.label = LanUtil.getValue(141411);
	else
		self.subButton.label = LanUtil.getValue(141413);
	end
end

function Lua_CrossServerGoldBuyItem:onBuyButtonClick()
	if self.data.state == 0 then
		if DataCenter.moneyData:getMoney(Lua_MoneyData.GOLD) < DataCenter.crossServerPurchasingData.getGoldPrice then
			Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {
				owner = self,
				des = LanUtil.getValue(110818),
				type = 1,
				subFun = self.onSubCallback
			});
		else
			Lua_ProxyManager.getProxy("Lua_CrossServerPurchasingProxy"):sCrossServerBuyInfo(DataCenter.crossServerPurchasingData.gold_buy_num, self.data.index);
		end
	else
		Lua_ProxyManager.getProxy("Lua_CrossServerPurchasingProxy"):sCrossServerRewardInfo(self.data.index);
		Lua_WindowUtil.openWin("Lua_CrossServerRewardWindow", WinParam.ACTION_OPEN,
			{itemVo = self.data.itemVo, reward_number = self.data.reward_number});
	end
end

function Lua_CrossServerGoldBuyItem:onSubCallback()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow");
	Lua_WindowUtil.openWin("Lua_CrossServerPurchasingWindow",WinParam.ACTION_CLOSE);
end

function Lua_CrossServerGoldBuyItem:dispose()
	self:superCall("dispose");
end